#include "validation.h"

int main(int argc, char** argv) {
	std::ifstream in(argv[1]);
	OutputValidator v(argc, argv);

	int n;
	in >> n;
	std::vector<int> weights(n);
	for(auto& w : weights) in >> w;

	int queries              = 0;
	int max_queries          = 20000;
	int max_executed_queries = 40000;

	std::cout << n << std::endl;

	while(true) {
		std::string op = v.test_strings({"?", "!"});
		if(op == "?") {
			queries += 1;
			v.check(queries <= max_executed_queries, "Over ", max_executed_queries, " queries.");
			v.space();
			int i = v.read_integer("i", 1, n) - 1;
			v.space();
			int j = v.read_integer("j", 1, n) - 1;
			v.newline();
			int wi = weights[i];
			int wj = weights[j];
			if(wi == wj) {
				std::cout << "=" << std::endl;
			}
			if(wi < wj) {
				std::cout << "<" << std::endl;
			}
			if(wi > wj) {
				std::cout << ">" << std::endl;
			}
		} else {
			assert(op == "!");
			v.space();
			auto ans = v.read_integers("ans", n, 1, n, Unique);
			v.newline();
			for(int i = 0; i < n - 1; ++i) {
				auto wi = weights[ans[i] - 1];
				auto wj = weights[ans[i + 1] - 1];
				v.check(wi <= wj, "Not sorted at position ", i, ": w(", ans[i], ") <= w(",
				        ans[i + 1], ") => ", wi, " <= ", wj);
			}
			v.check(queries <= max_queries, "Used ", queries, " > ", max_queries, " queries.");
			std::cerr << "Used " << queries << " queries." << std::endl;
			break;
		}
	}
}
